Tip 1: Solve at least 500 DSA questions.
Tip 2: Try to find the most optimal solution while coding.
Tip 3: Practice difficult DSA questions, as they are also assigned in interviews.
Tip 1: Mention your best ranks in global contests.
Tip 2: Mention open-source contributions if you have any.
I got the test link the day after the application. This round consisted of two DSA-based questions, both of medium difficulty. The test was conducted on HackerRank, and the duration of this round was 90 minutes.
If the string is: “abccba”, then the first repeated character is ‘c’, but the repeated character that is present first in the string is ‘a’. You need to print ‘a’.
Keep in mind that you need to print the repeated character that is present first in the string and not the first repeating character.
I first used the brute force approach with nested for loops to pass the test cases, then I used a HashMap to optimize my solution. I also wrote the time and space complexity of my solution in the comments.
On October 4, 2022, I got a call from the HR team of Goldman Sachs informing me that I had cleared the online round and asking when we could schedule an interview. We agreed to have the interview on October 5. The round was conducted on Microsoft Teams, and I had to use their IDE to solve two coding problems. The interview went well, and I solved both questions.
First, I explained the recursive solution to the interviewer, and then he asked me to optimize the solution. After that, I used dynamic programming to solve the question.
This round was also conducted on Microsoft Teams; it was around 1 PM. This time, the interviewer was not focusing on Data Structures and Algorithms but started to ask me system design questions. He then asked me to design the Amazon system. Since I am not good at system design, I was not able to give a proper explanation. So, I didn't clear this round.
Design Amazon.(Learn)
Tip 1: With DSA, focus on system design as well.
Tip 2: Designing to scale - design high-level, then drill down.
Tip 3: Communicate your approach to the interview clearly.
Here's your problem of the day
Solving this problem will increase your chance to get selected in this company
What is 3 + 2 * 4 based on operator precedence?